<?php
define('FORMPRESS_VERSION', '0.1');
/*
Plugin Name: FormPress
Plugin URI: http://almostdaniel.com/formpress
Description: This is a plugin that turns any WordPress installation into a web form database and processing agent.
Author: daniel spillers
Version: 0.1
Author URI: http://almostdaniel.com/
*/


/*  Copyright 2007  daniel spillers  (email : writeme@almostdaniel.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>

<?php
define('PLUGINDIR', 'wp-content/plugins');
define('FORMPRESSPLUGINDIR', ABSPATH.PLUGINDIR);
require_once(FORMPRESSPLUGINDIR.'/formpress/functions.php');
global $wp_db_version;
?>

<?php

function formpress_add_pages() {
	/* add_management_page(page_title, menu_title, access_level/capability, file, [function]); */
 	add_management_page(__('Forms'), __('Forms'), 5, 'formpress/manage.php');
}

function formpress_install() {
	global $wpdb;
	
	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	
	/* Create plugin tables if they do not already exist */
	
	$table_name = $wpdb->prefix . 'formpress_forms';
	if ( $wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ) {
		$SQL = "CREATE TABLE `$table_name` (
 			`ID` INT UNSIGNED NOT NULL AUTO_INCREMENT,
			`name` TEXT NOT NULL,
			`description` TEXT,
			`owner` BIGINT(20) NOT NULL,
			`notify` TINYINT(1),
			`email` TEXT,
			`confirmURI` TEXT,
			`dateCreated` DATETIME NOT NULL,
			PRIMARY KEY (`ID`)
			)
			CHARACTER SET utf8;";
		dbDelta($SQL);
	}
	
	$table_name = $wpdb->prefix . 'formpress_fields';
	if ( $wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ) {
		$SQL = "CREATE TABLE `$table_name` (
  			`ID` INT UNSIGNED NOT NULL AUTO_INCREMENT,
			`form` INT UNSIGNED NOT NULL,
			`name` TEXT NOT NULL,
			`description` TEXT,
			`size` INT UNSIGNED NOT NULL,
			`dateCreated` DATETIME NOT NULL,
			PRIMARY KEY (`ID`)
			)
			CHARACTER SET utf8;";
		dbDelta($SQL);
	}
	
	$table_name = $wpdb->prefix . 'formpress_data';
	if ( $wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ) {
		$SQL = "CREATE TABLE `$table_name` (
 			`session` INT UNSIGNED NOT NULL,
			`form` INT UNSIGNED NOT NULL,
			`field` INT UNSIGNED NOT NULL,
			`value` TEXT
			)
			CHARACTER SET utf8;";
		dbDelta($SQL);
	}
	
	add_option('formpress_version', FORMPRESS_VERSION);
}

function formpress_check_install() {
	$version = get_option('formpress_version');
	if ( empty($version) ) formpress_install();
}

function formpress_submit() {
	$form_ID = $_REQUEST['formpress_submit'];
	if ( !empty($form_ID) ) {

		formpress_do_submit($form_ID, $_REQUEST);

		exit;
	}
}

function formpress_export() {
	$form_ID = $_REQUEST['formpress_export'];
	if ( !empty($form_ID) ) {
		$format = $_REQUEST['format'];
		if ( !empty($format) ) formpress_do_export($form_ID, $format); 
	}
}

function formpress_css() {
	$site_url = get_bloginfo('url');
	echo '<link rel="stylesheet" type="text/css" href="'.$site_url.'/wp-content/plugins/formpress/css/index.css" />';
}


/* Actions */
if ( $wp_db_version >= 4772 ) {
	register_activation_hook(__FILE__, 'formpress_install');
} else {
	add_action('activate_formpress/formpress.php', 'formpress_install');
}

add_action('init', 'formpress_submit', 1);
add_action('init', 'formpress_export', 1);
add_action('plugins_loaded', 'formpress_check_instasll');
add_action('admin_head', 'formpress_css');
add_action('admin_menu', 'formpress_add_pages');

?>