<?php

function formpress_the_html($form_ID) {
	global $wpdb, $site_url;
	
	echo '<form action="'.$site_url.'/?formpress_submit='.$form_ID.'" method="post">'."\n";
	
	$field_list = formpress_get_field_list($form_ID);
	
	if ( $field_list ) {
		echo "<fieldset>\n";
		$i = 0;
		foreach ( $field_list as $field ) {
			$field_ID = $field->ID;
			$field_name = $field->name;
			$field_label = $form_ID . "-" . $field_ID;
			$field_description = $field->description;
			$field_size_original = $field->size;
			
			( $field_size_original > 50 ) ? $field_size = 50 : $field_size = $field_size_original;
			
			echo "\n";
			?>
            <label for="<?php echo $field_label; ?>"><?php echo $field_name; ?> <span class="description"><?php echo $field_description; ?></span></label>
            <input name="<?php echo $field_label; ?>" size="<?php echo $field_size; ?>" type="text" maxlength="<?php echo $field_size_original; ?>" tabindex="<?php echo ++$i; ?>" />
            <?php
			echo "\t";
		}
	} else {
		echo "\n<p>Insert input fields here.</p>";
	}
	echo "\n</fieldset>\n\n";
	?><p class="submit"><input name="submit" type="submit" value="Submit &amp;#187;" tabindex="<?php echo ++$i; ?>" /></p><?php
	echo "\n</form>";
}

function formpress_add_form($form_name, $form_description, $user_ID) {
	global $wpdb;
	
	// make it safe
	$form_name = $wpdb->escape($form_name);
	$form_description = $wpdb->escape($form_description);
	
	if ( !formpress_is_form($form_name) ) {
		$table_name = $wpdb->prefix . "formpress_forms";
		$now = date('Y-m-d H:i:s');
		$query = "INSERT INTO `$table_name` (name, description, owner, dateCreated) VALUES ('$form_name', '$form_description', $user_ID, '$now')";

		$wpdb->query($query);
		return $wpdb->insert_id;
	} else {
		// ERROR: Form already exists
	}
}

function formpress_save_form($form_ID, $request) {
	global $wpdb;
	$the_option_fields = formpress_get_form_option_fields();
	
	foreach ( $the_option_fields as $column => $field ) {
		$field_name = $field->Field;
		$value = $wpdb->escape($request[$field_name]);

		if ( $field_name != "ID" && $field_name != "owner" && $field_name != "dateCreated" ) {
			$the_list[] = "$field_name = '$value'";	
		}
	}
	$the_liststring = implode(", ", $the_list);
	
	$table_name = $wpdb->prefix . "formpress_forms";
	$query = "UPDATE `$table_name` SET $the_liststring WHERE ID = $form_ID";
	
	$wpdb->query($query);
	
	$the_fields = formpress_get_field_list($form_ID);
	
	if ( $the_fields ) {
		foreach ( $the_fields as $field ) {
			$field_ID = $field->ID;
			$field_name = $wpdb->escape($request["name-$field_ID"]);
			$field_description = $wpdb->escape($request["description-$field_ID"]);
			$field_size = $wpdb->escape($request["size-$field_ID"]);
			
			$table_name = $wpdb->prefix . "formpress_fields";
			$query = "UPDATE `$table_name` SET name = '".$field_name."', description = '".$field_description."', size = '".$field_size."' WHERE form = $form_ID AND ID = $field_ID";
			$wpdb->query($query);
		}
	}
		
	return true;
}

function formpress_delete_form($form_ID) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_fields";
	$query = "DELETE FROM `$table_name` WHERE form = $form_ID";
	$wpdb->query($query);

	$table_name = $wpdb->prefix . "formpress_forms";
	$query = "DELETE FROM `$table_name` WHERE ID = $form_ID";
	$wpdb->query($query);
	
	return true;
}

function formpress_delete_record($session_ID, $form_ID, $field_ID) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_data";
	$query = "DELETE FROM `$table_name` WHERE session = $session_ID AND form = $form_ID AND field = $field_ID";
	$wpdb->query($query);
	
	return true;
}

function formpress_delete_data($form_ID) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_data";
	$query = "DELETE FROM `$table_name` WHERE form = $form_ID";
	$wpdb->query($query);
	
	return true;
}

function formpress_get_form_option_fields() {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_forms";
	
	$result = $wpdb->get_results("DESC `$table_name`");
	
	return $result;	
}

function formpress_is_form($form_name) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_forms";
	
	$result = false;

	$result_var = $wpdb->get_var("SELECT ID FROM `$table_name` WHERE name = '$form_name'");
	
	if ( !empty($result_var) ) $result = true;

	return $result;
}

function formpress_get_form_option($form_ID, $option) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_forms";
	
	$result_var = $wpdb->get_var("SELECT $option FROM `$table_name` WHERE ID = $form_ID");
	
	return $result_var;
}

function formpress_form_name($form_ID) {
	$result = formpress_get_form_option($form_ID, 'name');
	
	echo $result;
}

function formpress_form_description($form_ID) {
	$result = formpress_get_form_option($form_ID, 'description');
	
	echo $result;
}

function formpress_form_confirmURI($form_ID) {
	$result = formpress_get_form_option($form_ID, 'confirmURI');
	
	echo $result;
}

function formpress_get_form_confirmURI($form_ID) {
	global $site_url;
	
	$result = formpress_get_form_option($form_ID, 'confirmURI');

	if ( empty($result) ) $result = $site_url;

	return $result;
}

function formpress_form_notify($form_ID) {
	$result = "";
	$result_var = formpress_get_form_option($form_ID, 'notify');
	
	if ( $result_var == 1 ) $result = "checked";

	echo $result;
}

function formpress_form_email($form_ID) {
	$result = formpress_get_form_option($form_ID, 'email');

	echo $result;
}

function formpress_form_has_notify($form_ID) {
	$result = false;
	$result_var = formpress_get_form_option($form_ID, 'notify');
	
	if ( $result_var == 1 ) $result = true;
	
	return $result;
}

function formpress_form_has_email($form_ID) {
	$result = false;
	$result_var = formpress_get_form_option($form_ID, 'email');
	
	if ( $result_var ) $result = true;
	
	return $result;
}

function formpress_form_list($type) {
	global $wpdb, $site_url, $manage_url, $submit_url;
	$table_name = $wpdb->prefix . "formpress_forms";
	
	$query = "SELECT * FROM `$table_name`";
	
	$form_list = $wpdb->get_results($query);
	
	switch ( $type ) {
		case 'table':
			if ( $form_list ) {
				$i = 1;
				foreach ( $form_list as $form ) {
					$row_class = ( $i++ % 2 == 1 ) ? "alternate" : "";
					?>
					<tr class="<?php echo $row_class; ?>">
					<th scope="row" style="text-align: center"><?php echo $form->ID; ?></th>
					<td><?php echo $form->name; ?></td>
					<td class="description"><?php echo $form->description; ?></td>
					
					<?php $user = get_userdata($form->owner); ?>
					<td><?php echo $user->display_name; ?></td>
					
					<td><a href="<?php echo $site_url.$manage_url; ?>&action=view&id=<?php echo $form->ID; ?>" class="edit">View/Export Results</a></td>
					<td><a href="<?php echo $site_url.$manage_url; ?>&action=editform&id=<?php echo $form->ID; ?>" class="edit">Edit Form</a></td>
					<td><a href="<?php echo $site_url.$manage_url; ?>&action=deleteform&id=<?php echo $form->ID; ?>" class="delete" onclick="return deleteSomething( 'You are about to delete this form. All results for this form will be lost. This action cannot be undone!\n\n\'OK\' to delete, \'Cancel\' to stop.' );">Delete Form</a></td>
                    <?php		
				}
			} else { 
				echo '<tr><td>No forms found.</td></tr>'."\n";
			}
			break;
		case 'list':
			if ( $form_list ) {
				$i = 1;
				foreach ( $form_list as $form ) {
					$row_class = ( $i++ % 2 == 1 ) ? "alternate" : "";
					echo '<li class="'.$row_class.'">'.$form->ID.'. ';
					echo $form->name."\n";
					echo '<ul>'."\n";
					echo '<li>'.$form->description.'</li>'."\n";
					
					$user = get_userdata($form->owner);
					echo '<li>'.$user->display_name.'</li>'."\n";
					echo '</ul></li>'."\n";
				}
			} else {
				echo '<li>No forms found.</li>'."\n";
			}
			break;
	}
}

function formpress_get_field_list($form_ID) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_fields";

	$query = "SELECT * FROM `$table_name` WHERE form = $form_ID";
	
	$result = $wpdb->get_results($query);

	return $result;
}

function formpress_field_list($form_ID, $type) {
	global $site_url, $manage_url;
	
	$field_list = formpress_get_field_list($form_ID);
	
	switch ( $type ) {
		case 'table':
			if ( $field_list ) {
				$i = 1;
				foreach ( $field_list as $field ) {
					$row_class = ( $i++ % 2 == 1 ) ? "alternate" : "";
					?>
					<tr class="<?php echo $row_class; ?>">
					<th scope="row"><input name="name-<?php echo $field->ID; ?>" size="25" value="<?php echo $field->name; ?>" /></th>
					<td><input name="description-<?php echo $field->ID; ?>" size="50" value="<?php echo $field->description; ?>" /></td>
					<td><input name="size-<?php echo $field->ID; ?>" size="5" value="<?php echo $field->size; ?>" /></td>
					<td><a href="<?php echo $site_url.$manage_url; ?>&action=deletefield&id=<?php echo $field->form; ?>&field=<?php echo $field->ID; ?>" class="delete" onclick="return deleteSomething( 'You are about to delete this field. Any results stored in this field will be lost. This action cannot be undone!\n\n\'OK\' to delete, \'Cancel\' to stop.' );">Delete</a></td>
					</tr>
                    <?php
				}
			} else {
				echo '<tr><td>No fields found.</td></tr>'."\n";
			}
			break;
		case 'list':
			if ( $field_list ) {
				$i = 1;
				foreach ( $field_list as $field ) {
					$row_class = ( $i++ % 2 == 1 ) ? "alternate" : "";
					echo '<li class="'.$row_class.'">'.$field->name."\n";
					echo '<ul><li>'.$field->description.'</li>'."\n";
					echo '<li>'.$field->size.'</li></ul>'."\n";
					echo '</li>'."\n";
				}
			} else {
				echo '<li>No fields found.</li>'."\n";
			}
			break;
	}
}

function formpress_add_field($form_ID, $field_name, $field_description, $field_size) {
	global $wpdb;
	
	// make it safe
	$field_name = $wpdb->escape($field_name);
	$field_description = $wpdb->escape($field_description);
	$field_size = $wpdb->escape($field_size);
	
	if ( !formpress_is_field($form_ID, $field_name) ) {
		$table_name = $wpdb->prefix . "formpress_fields";
		$now = date('Y-m-d H:i:s');
		$query = "INSERT INTO `$table_name` (form, name, description, size, dateCreated) VALUES ($form_ID, '$field_name', '$field_description', $field_size, '$now')";

		$wpdb->query($query);
		return $wpdb->insert_id;
	} else {
		// ERROR: Form already exists
	}	
}

function formpress_delete_field($form_ID, $field_ID) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_fields";
	
	$query = "DELETE FROM `$table_name` WHERE ID = $field_ID AND form = $form_ID";
	$wpdb->query($query);
	
	return true;
}

function formpress_is_field($form_ID, $field_name) {
	global $wpdb;
	$table_name = $wpdb->prefix . "formpress_fields";
	
	$result = false;
	
	$query = "SELECT ID FROM `$table_name` WHERE form = $form_ID AND name = '$field_name'";
	
	$result_var = $wpdb->get_var($query);
	
	if ( !empty($result_var) ) $result = true;
	
	return $result;
}

function formpress_results_head($form_ID, $prefix, $suffix) {
	global $wpdb;
	
	$table_name = $wpdb->prefix . "formpress_forms";
	$the_form = $wpdb->get_row("SELECT DISTINCT * FROM `$table_name` WHERE ID = $form_ID");
	
	$table_name = $wpdb->prefix . "formpress_fields";
	$the_fields = $wpdb->get_results("SELECT * FROM `$table_name` WHERE form = $form_ID");
	
	$form_name = $the_form->name;
	$form_description = $the_form->description;
	echo "<h3>$form_name</h3>\n";
	echo "<caption>$form_description</caption>\n";

	echo "$prefix\n";
	echo "<tr>\n";
	echo '<th scope="col"><div style="text-align: center">ID</div></th>'."\n";
	foreach ( $the_fields as $field ) {
		echo '<th scope="col">'.$field->name.'</th>'."\n";
	}
    echo '<th scope="col"><div style="text-align: center">Action</div></th>'."\n";
	echo "</tr>\n";
	echo "$suffix\n";
}

function formpress_get_results_head($form_ID, $prefix, $suffix) {
	global $wpdb;

	$table_name = $wpdb->prefix . "formpress_forms";
	$the_form = $wpdb->get_row("SELECT DISTINCT * FROM `$table_name` WHERE ID = $form_ID");
	
	$table_name = $wpdb->prefix . "formpress_fields";
	$the_fields = $wpdb->get_results("SELECT * FROM `$table_name` WHERE form = $form_ID");
	
	$form_name = $the_form->name;
	$form_description = $the_form->description;
	$result .= "<h3>$form_name</h3>\n";
	$result .= "<caption>$form_description</caption>\n";

	$result .= "$prefix\n";
	$result .= "<tr>\n";
	$result .= '<th scope="col"><div style="text-align: center">ID</div></th>'."\n";
	foreach ( $the_fields as $field ) {
		$result .= '<th scope="col">'.$field->name.'</th>'."\n";
	}
    $result .= '<th scope="col"><div style="text-align: center">Action</div></th>'."\n";
	$result .= "</tr>\n";
	$result .= "$suffix\n";
	
	return $result;
}

function formpress_results_data($form_ID, $prefix, $suffix, $the_session) {
	global $wpdb, $site_url, $manage_url;
	
	$table_name = $wpdb->prefix . "formpress_fields";
	$the_fieldnames = $wpdb->get_results("SELECT name FROM `$table_name` WHERE form = $form_ID");
	
		$table_name = $wpdb->prefix . "formpress_data";
	if ( empty($the_session) ) {
		$the_sessions = $wpdb->get_results("SELECT DISTINCT session FROM `$table_name` WHERE form = $form_ID ORDER BY session ASC");
	} else {
		$the_sessions = $wpdb->get_results("SELECT DISTINCT session FROM `$table_name` WHERE form = $form_ID AND session = $session ORDER BY session ASC");
	}
		
	echo "$prefix\n";
	
	if ( $the_sessions ) {
		$i = 1;
		foreach ( $the_sessions as $session ) {
			$session_ID = $session->session;
			$table_name1 = $wpdb->prefix . "formpress_data";
			$table_name2 = $wpdb->prefix . "formpress_fields";
			$the_dataset = $wpdb->get_results("SELECT $table_name1.field, $table_name2.name AS fieldname, $table_name1.value FROM `$table_name1`, `$table_name2` WHERE $table_name1.form = $form_ID AND $table_name1.session = $session_ID AND $table_name1.field = $table_name2.ID");
			
			( $i++ % 2 == 1 ) ? $row_class = "alternate" : $row_class = "";
			
			echo '<tr class="'.$row_class.'">'."\n";
			echo '<th scope="row"><div style="text-align: center">'.$session_ID.'</div></td>'."\n";
			
			foreach ( $the_fieldnames as $fieldname ) {
				$data_there = false;
				foreach ( $the_dataset as $record ) {
					if ( $fieldname->name == $record->fieldname ) {
						echo "<td>$record->value</td>\n";
						$data_there = true;
					}
				}
				
				if ( !$data_there ) echo "<td>&nbsp;</td>\n";
			}

			echo "<td><div style='text-align: center'><a href='".$site_url.$manage_url."&action=deleterecord&session=".$session_ID."&form=".$form_ID."&field=".$record->field."'>Delete</a></div></td>";
			
			echo "</tr>\n";
		}
	} else {
		$count = count($the_fieldnames);
		echo '<tr><td colspan="'.$count.'">No results found.</td></tr>'."\n";
	}
	echo "$suffix\n";
}

function formpress_get_results_data($form_ID, $prefix, $suffix, $the_session) {
	global $wpdb;
	
	$table_name = $wpdb->prefix . "formpress_fields";
	$the_fieldnames = $wpdb->get_results("SELECT name FROM `$table_name` WHERE form = $form_ID");
	
		$table_name = $wpdb->prefix . "formpress_data";
	if ( empty($the_session) ) {
		$the_sessions = $wpdb->get_results("SELECT DISTINCT session FROM `$table_name` WHERE form = $form_ID ORDER BY session ASC");
	} else {
		$the_sessions = $wpdb->get_results("SELECT DISTINCT session FROM `$table_name` WHERE form = $form_ID AND session = $the_session ORDER BY session ASC");
	}
		
	$result .= "$prefix\n";
	
	if ( $the_sessions ) {
		$i = 1;
		foreach ( $the_sessions as $session ) {
			$table_name1 = $wpdb->prefix . "formpress_data";
			$table_name2 = $wpdb->prefix . "formpress_fields";
			$the_dataset = $wpdb->get_results("SELECT $table_name1.field, $table_name2.name AS fieldname, $table_name1.value FROM `$table_name1`, `$table_name2` WHERE $table_name1.form = $form_ID AND $table_name1.session = $session->session AND $table_name1.field = $table_name2.ID");
			
			( $i++ % 2 == 1 ) ? $row_class = "alternate" : $row_class = "";
			
			$result .= '<tr class="'.$row_class.'">'."\n";
			$result .= '<th scope="row">'.$session->session.'</td>'."\n";
			
			foreach ( $the_fieldnames as $fieldname ) {
				$data_there = false;
				foreach ( $the_dataset as $record ) {
					if ( $fieldname->name == $record->fieldname ) {
						$result .= "<td>$record->value</td>\n";
						$data_there = true;
					}
				}
				
				if ( !$data_there ) echo "<td>&nbsp;</td>\n";
			}
			$result .= "</tr>\n";
		}
	} else {
		$result .= '<tr><td>No results found.</td></tr>'."\n";
	}
	$result .= "$suffix\n";
	
	return $result;
}

function formpress_do_submit($form_ID, $request) {
	global $wpdb;

	$site_url = get_bloginfo('url');

	if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {
		$the_session = formpress_next_session();
		
		$field_list = formpress_get_field_list($form_ID);
		
		foreach ( $request as $formitem => $formvalue ) {
			$pieces = split("-", $formitem);
			if ( count($pieces) > 2 ) {
				$item = $pieces[0] . "-" . $pieces[1];
				$count = $pieces[2];
				$multivalueitems[$item][$count] = $formvalue;
			}
		}

		foreach ( $field_list as $field ) {
			$the_list = "";
			$field_name = $field->name;
			$field_ID = $field->ID;
			$field_label = $form_ID . "-" . $field_ID;
			
			$value = $wpdb->escape($request[$field_label]);
			
			if ( empty($value) && count($multivalueitems[$field_label]) != 0 ) {
				foreach ( $multivalueitems[$field_label] as $valueitem) {
					if ( !empty($valueitem) ) $the_values[] = $wpdb->escape($valueitem);
				}
				$value = implode(", ", $the_values);
				
				unset($the_values);
			}
			
			$value = "'".$value."'";
			
			if ( !empty($value) && $field_name != "ID" ) {
				$the_list = array($the_session, $form_ID, $field_ID, $value);
			}
			
			$the_liststring = implode(", ", $the_list);
			
			$table_name = $wpdb->prefix . "formpress_data";
			$query = "INSERT INTO `$table_name` VALUES ($the_liststring)";

			$wpdb->query($query);
		}
	
		if ( formpress_form_has_notify($form_ID) ) formpress_do_email($form_ID, $the_session);
	}
	
	$form_confirmURI = formpress_get_form_confirmURI($form_ID);
	if ( $form_confirmURI ) {
		wp_redirect($form_confirmURI);
	} else {
		wp_redirect($site_url);
	}
}

function formpress_do_email($form_ID, $the_session) {
	$form_email = formpress_get_form_option($form_ID, 'email');
	
	$form_name = formpress_get_form_option($form_ID, 'name');
	
	$the_headers = "MIME-Version: 1.0\n" .
		"From: wordpress@" . preg_replace('#^www\.#', '', strtolower($_SERVER['SERVER_NAME'])) . "\n" . 
		"Content-Type: text/html; charset=UTF-8\n";
	
	$the_message .= '<body><table>';
	$the_message .= formpress_get_results_head($form_ID, '<thead>', '</thead>');
	$the_message .= formpress_get_results_data($form_ID, '<tbody>', '</tbody>', $the_session);
	$the_message .= '</table></body>';

	wp_mail($form_email, "Form submitted ($form_name)", $the_message, $the_headers);
}

function formpress_next_session() {
	global $wpdb;
	$last_session = 0;
	$table_name = $wpdb->prefix . "formpress_data";
	$last_session = $wpdb->get_var("SELECT MAX(session) FROM `$table_name");
	
	return $last_session + 1;
}

function formpress_do_export($form_ID, $format) {
	global $wpdb;
	$form_name = formpress_get_form_option($form_ID, 'name');
	$form_name = str_replace(" ", "-", $form_name);
	
	$filename = $form_name . '.' . date('Y-m-d');
	
	switch ( $format ) {
		case 'tab':
			$filename = $filename . '.txt';
			break;
	}
	
	header('Content-Description: File Transfer');
	header("Content-Disposition: attachment; filename=$filename");
	header('Content-Type: text/plain; charset=UTF-8');
	
	$table_name = $wpdb->prefix . "formpress_fields";
	$the_fieldnames = $wpdb->get_results("SELECT name FROM `$table_name` WHERE form = $form_ID");
	
	echo "ID\t";
	
	foreach ( $the_fieldnames as $fieldname ) {
		echo $fieldname->name . "\t";	
	}
	
	$table_name = $wpdb->prefix . "formpress_data";
	
	$the_sessions = $wpdb->get_results("SELECT DISTINCT session FROM `$table_name` WHERE form = $form_ID ORDER BY session ASC");
	
	if ( $the_sessions ) {
		foreach ( $the_sessions as $session ) {
			$table_name1 = $wpdb->prefix . "formpress_data";
			$table_name2 = $wpdb->prefix . "formpress_fields";
			$the_dataset = $wpdb->get_results("SELECT $table_name1.field, $table_name2.name AS fieldname, $table_name1.value FROM `$table_name1`, `$table_name2` WHERE $table_name1.form = $form_ID AND $table_name1.session = $session->session AND $table_name1.field = $table_name2.ID");
			
			$line = "\n" . $session->session . "\t";
			
			foreach ( $the_fieldnames as $fieldname ) {
				foreach ( $the_dataset as $record ) {
					if ( $fieldname->name == $record->fieldname ) {
						$line .= $record->value . "\t";
					}
				}
			}
			
			echo $line;
		}
	}
die();	
}



/* Action Functions */

function formpress_notice_addform() {
	$msg = __('<strong>Form added.</strong> Please add <a href="#editform">form fields</a> before submitting data.');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_addfield() {
	$msg = __('<strong>Field added.</strong>');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_deleteform() {
	$msg = __('<strong>Form deleted.</strong>');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_deletefield() {
	$msg = __('<strong>Field deleted.</strong>');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_deletedata() {
	$msg = __('<strong>All data deleted.</strong>');
	
	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_saveform() {
	$msg = __('<strong>Saved.</strong>');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}

function formpress_notice_export() {
	$msg = __('<strong>Results exported.</strong>');

	echo '<div id="message" class="updated fade"><p>'.$msg.'</p></div>';
}


?>