<?php
require_once(FORMPRESSPLUGINDIR.'/formpress/functions.php');
$site_url = get_bloginfo('url');
$base_url = "/wp-admin/edit.php?page=formpress";
$manage_url = $base_url . "/manage.php";
$export_url = $base_url . "/export.php";
$plugin_url = "/wp-content/plugins/formpress/";

function formpress_show_manage_page() {
	global $user_ID, $user_email, $site_url, $manage_url, $export_url, $plugin_url;
	get_currentuserinfo();

	echo "<script type='text/javascript' src='".$site_url.$plugin_url."js/index.js'></script>\n";

	switch ( $_REQUEST['status'] ) {
		case 'addfield':
			formpress_notice_addfield();
			break;
		case 'deleteform':
			formpress_notice_deleteform();
			break;
		case 'deletefield':
			formpress_notice_deletefield();
			break;
		case 'deletedata':
			formpress_notice_deletedata();
			break;
		case 'saveform':
			formpress_notice_saveform();
			break;
		case 'export':
			formpress_notice_export();
			break;
	}

	switch ( $_REQUEST['action'] ) {
		case 'addform':
			$form_name = $_REQUEST['name'];
			$form_description = $_REQUEST['description'];
			if ( !empty($form_name) || !empty($user_ID) ) {
				// store form in db and grab ID
				$form_ID = formpress_add_form($form_name, $form_description, $user_ID);
				add_action( 'admin_notices', 'formpress_notice_addform', 3 );
				do_action( 'admin_notices' );
			} else {
				// ERROR
			}
					
		case 'editform':
			if ( empty($form_ID) ) $form_ID = $_REQUEST['id'];
			
			?>
            <div class="wrap">
            	<h2>Edit Form</h2>
                <form name="editform" id="editform" action="<?php echo $site_url.$manage_url; ?>&action=saveform&id=<?php echo $form_ID; ?>" method="post">
				<p>Here you finish configuring your form's dataset and behavior. Add a form field for each piece of data you'd like to collect. You can also change form options or preview some example HTML used to build the form's web page.</p>
                <ul>
                    <li><a href="#options">Options</a></li>
                    <li><a href="#example">Example HTML</a></li>
                </ul>
                <h3>Data Fields (<a href="<?php echo $site_url.$manage_url."&action=showfield&id=".$form_ID; ?>">add new</a>)</h3>
                <table class="widefat">
                <thead>
                <tr>
                	<th scope="col">Name</th>
                    <th scope="col">Description</th>
                    <th scope="col">Size</th>
                    <th scope="col">&nbsp;</th>
                </tr>
                </thead>
                <tbody>
                
                <?php formpress_field_list($form_ID, 'table'); ?>
                
                </tbody>
                </table>
				
                <p class="submit"><input name="update" type="submit" value="Update" /></p>

                <h3 id="options">Options</h3>
                <table class="optiontable">
                <tr>
                <th scope="row">Form Name:</th>
                <td><input name="name" id="name" size="40" value="<?php formpress_form_name($form_ID); ?>" /></td>
                </tr>
                <tr>
                <th scope="row">Description (optional):</th>
                <td><input name="description" id="description" size="40" value="<?php formpress_form_description($form_ID); ?>"  /></td>
                </tr>
                <tr>
                <th scope="row">Confirmation URL (optional):<span class="description">Display this page after a form is submitted.</span></th>
                <td><input name="confirmURI" id="confirmURI" size="40" value="<?php formpress_form_confirmURI($form_ID); ?>"  /></td>
                </tr>
                <tr>
                <th scope="row">Email Notification (optional):<span class="description">Send email notification each time a form is submitted. Separate multiple
                email addresses with a comma.</span></th>
                <td>
                <fieldset>
                <ul>
                    <li>
                    <label for="notify">Activate Email Notification:</label> 
                    <input name="notify" id="notify" type="checkbox" value="1" <?php formpress_form_notify($form_ID); ?> />
                   	</li>
                    <li>
                    <label for="email">Email Address(es):</label> 
                    <input name="email" id="email" size="40" value="<?php formpress_form_email($form_ID); ?>" /> 
                    </li>
                </ul>
                </fieldset>
                </td>
                </tr>     
                </table>

                <p class="submit"><input name="update" type="submit" value="Update" /></p>

				<h3 id="example">Example HTML</h3>
            	<p>Copy and paste the contents of this textbox into the HTML (Code) view of a Post or Page to test the form.</p>
            	<textarea id="examplehtml" rows="25" cols="75"><?php formpress_the_html($form_ID); ?></textarea>                
                <p>Use the following URL as the <em>action</em> attribute for your HTML form page:</p>
                <p><input id="actionurl" type="text" size="99" value="<?php echo $site_url; ?>?formpress_submit=<?php echo $form_ID; ?>" /></p>
                </form>
            </div>
            <?php
			
			break;
		case 'saveform':
			$form_ID = $_REQUEST['id'];
			$result = formpress_save_form($form_ID, $_REQUEST);
		
			echo "<div class='wrap'><p>Processing ...</p></div>";
			wp_redirect($site_url.$manage_url."&status=saveform&action=editform&id=".$form_ID);
			
			break;
		case 'deleteform':
			$form_ID = $_REQUEST['id'];
			$result = formpress_delete_form($form_ID);
			echo '<div class="wrap"><p>Processing...</p></div>';
			if ( $result ) wp_redirect($site_url.$manage_url."&status=deleteform");
			break;
		case 'deletefield':
			$form_ID = $_REQUEST['id'];
			$field_ID = $_REQUEST['field'];
			$result = formpress_delete_field($form_ID, $field_ID);
			echo '<div class="wrap"><p>Processing...</p></div>';
			if ( $result ) wp_redirect($site_url.$manage_url."&status=deletefield&action=editform&id=$form_ID");
			break;
		case 'deleterecord':
			$session_ID = $_REQUEST['session'];
			$form_ID = $_REQUEST['form'];
			$field_ID = $_REQUEST['field'];
			$result = formpress_delete_record($session_ID, $form_ID, $field_ID);
			echo '<div class="wrap"><p>Processing...</p></div>';
			if ( $result ) wp_redirect($site_url.$manage_url."&status=deleterecord&action=view&id=$form_ID");
			break;
		case 'deletedata':
			$form_ID = $_REQUEST['id'];
			$result = formpress_delete_data($form_ID);
			echo '<div class="wrap"><p>Processing...</p></div>';
			if ( $result ) wp_redirect($site_url.$manage_url."&status=deletedata&action=view&id=$form_ID");
			break;	
		case 'showfield':
			$form_ID = $_REQUEST['id'];

			do_action( 'admin_notices' );
			
			?>
			<div class="wrap">
				<h2>Add Data Field</h2>
                <form name="showfield" id="showfield" action="<?php echo $site_url.$manage_url; ?>&action=addfield&id=<?php echo $form_ID; ?>" method="post">
		        <table class="optiontable" width="100%" cellspacing="2" cellpadding="5">
                <tr>
                <th scope="row">Field Name:</span></th>
                <td><input name="name" id="name" size="50" /></td>
                </tr>
                <tr>
                <th scope="row">Description (optional):</th>
                <td><input name="description" id="description" size="50" /></td>
                </tr>
                <tr>
                <th scope="row">Character Limit:<span class="description">Determine the maximum number of characters<br />that can be stored in this field.</span></th>
                <td><input name="size" id="size" size="5" /></td>
                </tr>
                </table>
                <p class="submit"><input name="addfield" type="submit" value="Add Field &#187;" /></p>
                </form>
			</div>
            
            <?php
			break;
		case 'addfield':
			$form_ID = $_REQUEST['id'];
			$field_name = $_REQUEST['name'];
			$field_description = $_REQUEST['description'];
			$field_size = $_REQUEST['size'];
			
			if ( !empty($field_name) || !empty($field_size) || !empty($user_ID) ) {
				// store form in db and grab ID
				$field_id = formpress_add_field($form_ID, $field_name, $field_description, $field_size);
				echo '<div class="wrap"><p>Processing...</p></div>';		
			} else {
				// ERROR
			}

			wp_redirect($site_url.$manage_url."&status=addfield&action=editform&id=".$form_ID);
			break;
		case 'view':
			$form_ID = $_REQUEST['id'];
			?>
            <div class="wrap">
            	<h2>Results (<a href="<?php echo $site_url.$manage_url; ?>&action=viewexport&id=<?php echo $form_ID; ?>">export to file</a>)</h2>
                <table class="widefat">
                <?php formpress_results_head($form_ID, '<thead>', '</thead>'); ?>
                <?php formpress_results_data($form_ID, '<tbody>', '</tbody>'); ?>
                </table>
                <form name="export" id="export" action="<?php echo $site_url.$manage_url; ?>&action=deletedata&id=<?php echo $form_ID; ?>" method="post">
                <p class="submit"><input name="export" type="submit" value="Delete All Results"  onclick="return deleteSomething( 'You are about to delete all results stored for this form. This action cannot be undone!\n\n\'OK\' to delete, \'Cancel\' to stop.' );" /></p>
                </form>
            </div>
            <?php
			break;
		case 'viewexport':
			$form_ID = $_REQUEST['id'];
			$form_name = formpress_get_form_option($form_ID, 'name');
			?>
            <div class="wrap">
				<h2>Export Results</h2>
                <div class="narrow">
                <h3>Form: <?php echo $form_name; ?></h3>
                <p>When you click the button below, FormPress will create a file based on the selected file format for you to save to your computer.</p>
                <p>The file will contain all of the current results for this form.</p>
                <form name="export" id="export" action="<?php echo $site_url; ?>/?formpress_export=<?php echo $form_ID; ?>" method="post">
                <h3>File Format</h3>
				<select name="format" id="format">
                	<option value="tab">Tab-delimited text</option>
                </select>
                <p class="submit"><input name="export" type="submit" value="Download Export File &#187;" /></p>
                </form>
                </div>
            </div>
            <?php
			break;
		default:
	?>
	<div class="wrap">
		<h2>Forms (<a href="#addnew">add new</a>)</h2>
		<p>A web form has three parts that work together: the HTML page that displays the form, the script that processes a submission of form data, and a database where the data can be stored. This tool helps you to setup the database for a form, processes any form submissions, and also provides example HTML code useful in building the form's web page. <a href="#addnew">Add a new form below &#187;</a></p>
        <table class="widefat">
        <thead>
        <tr>
        <th scope="col"><div style="text-align: center">ID</div></th>
        <th scope="col">Name</th>
        <th scope="col">Description</th>
        <th scope="col">Owner</th>
        <th scope="col" colspan="3"><div style="text-align: center">Action</div></th>
        </tr>
        </thead>
        <tbody id="the-list"> 

        <?php formpress_form_list('table'); ?>
        
        </tbody>
        </table>
	</div>
	
	<div class="wrap">
		<h2 id="addnew">Add Form</h2>
        <form name="addform" id="addform" action="<?php echo $site_url . $manage_url; ?>&action=addform" method="post">
        <table class="optiontable" width="100%" cellspacing="2" cellpadding="5">
		<tr>
        <th scope="row">Form Name:</th>
        <td><input name="name" id="name" size="50" /></td>
        </tr>
        <tr>
        <th scope="row">Description (optional):</th>
        <td><input name="description" id="description" size="50" /></td>
        </tr>        
        </table>
        <p class="submit"><input name="createform" type="submit" value="Add Form &#187;" /></p>
        </form>
	</div>
    <?php
	}
}

formpress_show_manage_page();

?>